from ngsolve import *
import netgen.gui

from ngsolve import ngsglobals
import netgen.occ as occ

ngsglobals.msg_level = 2

file = "simpleHull.iges"
cadImp = occ.OCCGeometry(file)

### Mesh cad-import ###
mesh = Mesh(cadImp.GenerateMesh(maxh=10))#.Curve(3) # assemble geometry and mesh with maximal mesh-size = maxh
Draw(mesh)
input("pause")

### Extract shape from cad-import and move the shape center to origo ###
cadImp_shape = cadImp.shape
bb = cadImp_shape.bounding_box
pmin = bb[0]
pmax = bb[1]
center = occ.Pnt(\
            (pmin.x + pmax.x) / 2, \
            (pmin.y + pmax.y) / 2, \
            (pmin.z + pmax.z) / 2 \
        )
disp = occ.Vec( \
            -center.x, \
            -center.y, \
            -center.z  \
        )
cadImp_shape = cadImp_shape.Move(disp)

### Add a sphere to the geometry ###
x_sp = -50
y_sp = -200
z_sp = 0
sp = occ.Sphere(occ.Pnt(x_sp,y_sp,z_sp), r = 5)   
sp.maxh = 1 
sp.mat("ball")
for face in sp.faces:
    face.col =  (1,0,0) # give sphere red faces
rest = cadImp_shape - sp ### subtract the sphere from cad-import geometry 

### Make compound and mesh ###
geo = occ.Compound([rest, sp])
geo = occ.OCCGeometry(geo)
mesh = Mesh(geo.GenerateMesh(maxh=20))#.Curve(3) # assemble geometry and mesh with maximal mesh-size = maxh
Draw(mesh)
input("pause")